//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
#include "Math.h"
#include "stdio.h"
#include "system.hpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfMain *fMain;

//---------------------------------------------------------------------------

	AnsiString WorkDir, ExeFileName;

// type
	struct TFieldM { // 12
		AnsiString Name; // 4
		__int32 X, Y; // 4
		__int32 Code; // 4
	};
	DynamicArray<TFieldM> FieldsM;
	int FieldsMCount;

	struct TFieldS { // 16
		__int32 F, T, L; // 12
		DynamicArray<TPoint> PolyLine; // 4
	};
	DynamicArray<TFieldS> FieldsS;
	int FieldsSCount;

#define TFlo double

	int MinX, MinY, MaxX, MaxY;
	int MapCX, MapCY;
	TFlo ZoomX, ZoomY;
	int OX, OY;
	int StartPoint, NearPoint;

#define MaxPoints 100000
#define string AnsiString

int LineId[MaxPoints];
int PointCount;
int LinesCount;
int AFrom[MaxPoints];
int ATo[MaxPoints];
int LineLen[MaxPoints];
int MoveLen[MaxPoints];
int Mon[MaxPoints];
int VisitCount[MaxPoints];
int MoveId[MaxPoints];
int Stack1[MaxPoints];
int Stack2[MaxPoints];

int Roads[MaxPoints];
int Pnts[MaxPoints];

AnsiString Copy(AnsiString s, int From, int Count)
{
	return s.SubString(From, Count);
}

AnsiString ReadToChar(AnsiString Line, int &InLineIndex, char C)
{

	int NumStart;
	if (InLineIndex > Line.Length()) return "";
	NumStart = InLineIndex;
	while ((InLineIndex <= Line.Length()) && (Line[InLineIndex] != C))
		InLineIndex++;
	InLineIndex++;
	return Copy(Line, NumStart, InLineIndex - 1 - NumStart);
}

AnsiString DelFileExt(const string FName)
{
	AnsiString Result, Ext;

	Result = FName;
	Ext = ExtractFileExt(FName);
	if (Ext.Length() > 0) Result.SetLength(Result.Length() - Ext.Length());
	return Result;
};

void InitData()
{
	int i, j;

	if (FieldsMCount == 0)
	{
		MinX = 0;
		MinY = 0;
		MaxX = 0;
		MaxY = 0;
	}
	else
	{
		MinX = MaxInt;
		MinY = MaxInt;
		MaxX = -MaxInt;
		MaxY = -MaxInt;
		for (i = 0; i < FieldsMCount; i++)
		{
			if (FieldsM[i].X < MinX)
				MinX = FieldsM[i].X;
			if (-FieldsM[i].Y < MinY)
				MinY = -FieldsM[i].Y;
			if (FieldsM[i].X > MaxX)
				MaxX = FieldsM[i].X;
			if (-FieldsM[i].Y > MaxY)
				MaxY = -FieldsM[i].Y;
		};
		for (i = 0; i < FieldsSCount; i++)
		{
			for (j = 0; j < FieldsS[i].PolyLine.Length; j++)
			{
				if (FieldsS[i].PolyLine[j].x < MinX)
					MinX = FieldsS[i].PolyLine[j].x;
				if (-FieldsS[i].PolyLine[j].y < MinY)
					MinY = -FieldsS[i].PolyLine[j].y;
				if (FieldsS[i].PolyLine[j].x > MaxX)
					MaxX = FieldsS[i].PolyLine[j].x;
				if (-FieldsS[i].PolyLine[j].y > MaxY)
					MaxY = -FieldsS[i].PolyLine[j].y;
			};
		};
	};

	int B;
	bool First;

	PointCount = 0; //FieldsMCount;
	LinesCount = 0; //FieldsSCount;

	for (j = 0; j < FieldsMCount; j++)
	{
		First = false;
		AFrom[PointCount] = LinesCount;
		PointCount++;
		for (i = 0; i < FieldsSCount; i++)
		{
			B = (int)(FieldsS[i].F == FieldsM[j].Code) + ((int)(FieldsS[i].T == FieldsM[j].Code) << 1);
			if (B != 0)
			{
				if (First == False)
				{
					First = True;
				};
				if (B == 1)
					ATo[LinesCount] = FieldsS[i].T;
				else // B = 2 then
					ATo[LinesCount] = FieldsS[i].F;
				LineLen[LinesCount] = FieldsS[i].L;
				LineId[LinesCount] = i;
				LinesCount++;
			};
		};
	};
	AFrom[PointCount] = LinesCount;
};

void FreeMaps()
{
	StartPoint = -1;
	NearPoint = -1;
	FieldsMCount = 0;
	FieldsM.Length = 0;
	FieldsSCount = 0;
	FieldsS.Length = 0;
}

void ReadFromFile(AnsiString FileName)
{
	int i;

	char Buf[256];
	FILE* TextF;
	AnsiString Line, s;
	int InLineIndex;
	int Index;

	// M.mif
	if ((TextF = fopen(FileName.c_str(), "r")) == 0)
	{

	}
	else
	{
		while (!feof(TextF))
		{
			Buf[0] = (char)0;
			fgets(Buf, 256, TextF);
			if (strlen(Buf) > 4)
			{
				Line = Buf;
				Line.SetLength(Line.Length() - 1);

				InLineIndex = 1;
				s = ReadToChar(Line, InLineIndex, ' ');
				if (s == "Point")
				{
					FieldsMCount++;
					FieldsM.set_length(FieldsMCount);
					FieldsM[FieldsMCount - 1].X = StrToInt(ReadToChar(Line, InLineIndex, ' '));
					FieldsM[FieldsMCount - 1].Y = StrToInt(ReadToChar(Line, InLineIndex, ' '));
				}
			}
		}
		fclose(TextF);
	};

	// M.mid
	FileName = DelFileExt(FileName) + ".mid";

	if ((TextF = fopen(FileName.c_str(), "r")) == 0)
	{

	}
	else
	{
		i = 0;
		while (!feof(TextF))
		{
			Buf[0] = (char)0;
			fgets(Buf, 256, TextF);
			if (strlen(Buf) > 4)
			{
				Line = Buf;
				Line.SetLength(Line.Length() - 1);

				InLineIndex = 1;
				FieldsM[i].Code = StrToInt(ReadToChar(Line, InLineIndex, ','));
				FieldsM[i].Name = ReadToChar(Line, InLineIndex, (char)10);
				i++;
			}
		}
		fclose(TextF);
	};

	int Where;
	// S.mif
	s = ExtractFileName(FileName);
	s[1] = 'S';
	FileName = ExtractFilePath(FileName) + s;
	FileName = DelFileExt(FileName) + ".mif";
	if ((TextF = fopen(FileName.c_str(), "r")) == 0)
	{

	}
	else
	{
		while (!feof(TextF))
		{
			Buf[0] = (char)0;
			fgets(Buf, 256, TextF);
			if (strlen(Buf) > 3)
			{
				Line = Buf;
				Line.SetLength(Line.Length() - 1);

				InLineIndex = 1;
				s = ReadToChar(Line, InLineIndex, ' ');
				if (s == "Pline")
				{
					FieldsSCount++;
					FieldsS.set_length(FieldsSCount);
					s = ReadToChar(Line, InLineIndex, ' ');
					Where = StrToInt(s);
					FieldsS[FieldsSCount - 1].PolyLine.set_length(Where);
					Where = 0;
				}
				else if (s != "")
				{
					if (FieldsSCount > 0)
					if (Where < FieldsS[FieldsSCount - 1].PolyLine.get_length())
					{
						FieldsS[FieldsSCount - 1].PolyLine[Where].x = StrToInt(s);
						s = ReadToChar(Line, InLineIndex, ' ');
						FieldsS[FieldsSCount - 1].PolyLine[Where].y = StrToInt(s);

						Where++;
					}
				}
			}
		}
		fclose(TextF);
	};

	// S.mid
	FileName = DelFileExt(FileName) + ".mid";
	if ((TextF = fopen(FileName.c_str(), "r")) == 0)
	{

	}
	else
	{
		i = 0;
		while (!feof(TextF))
		{
			Buf[0] = (char)0;
			fgets(Buf, 256, TextF);
			if (strlen(Buf) > 4)
			{
				Line = Buf;
				Line.SetLength(Line.Length() - 1);

				InLineIndex = 1;
				FieldsS[i].F = StrToInt(ReadToChar(Line, InLineIndex, ','));
				FieldsS[i].T = StrToInt(ReadToChar(Line, InLineIndex, ','));
				FieldsS[i].L = StrToInt(ReadToChar(Line, InLineIndex, ','));
				i++;
			}
		}
		fclose(TextF);
	};
	InitData();
}

int WayCalc(int FromP, int ToP)
{
	int i, j, Stack1C, Stack2C, MinLen, n, m, Len, ToM, StackI;

	for (i = 0; i <= PointCount; i++)
	{
		MoveLen[i] = MaxInt;
		Mon[i] = 0;
		VisitCount[i] = 0;
	}

	MoveLen[FromP] = 0;
	Mon[FromP] = FromP;
	MoveId[FromP] = 0;

	Stack1[0] = FromP;
	Stack1C = 1;

	_LARGE_INTEGER Tim, Tim2;
	QueryPerformanceCounter(&Tim);

	n = 0;
	do
	{
		n++;
		MinLen = MaxInt;
		Stack2C = 0;
		for (i = 0; i < Stack1C; i++)
		{
			StackI = Stack1[i];
			for (m = AFrom[StackI - 1];m < AFrom[StackI]; m++)
			{
				Len = MoveLen[StackI] + LineLen[m];
				ToM = ATo[m];
				if (Len < MoveLen[ToM])
				{
					MoveLen[ToM] = Len;

					MoveId[ToM] = LineId[m];
					Mon[ToM] = StackI;

					if (Len<MinLen) MinLen = Len;

					if (VisitCount[ToM] < n)
					{
						Stack2[Stack2C] = ToM;
						Stack2C++;
						VisitCount[ToM] = n;

					}
				}
			}
		}

		Stack1C = Stack2C;

		for (i = 0; i < Stack2C; i++)
		{
			Stack1[i] = Stack2[i];
		}

	} while ((Stack1C > 0) && (MoveLen[ToP] > MinLen));

	QueryPerformanceCounter(&Tim2);
	Tim.QuadPart = Tim2.QuadPart - Tim.QuadPart;
	fMain->EditTime->Text = Tim.QuadPart;

	Stack1[0] = ToP;
	//Stack2[0]=MoveId[ToP];
	Stack1C = 1;

	while ((Stack1[Stack1C - 1] != FromP) && (Stack1C < MaxPoints))
	{
		Stack1[Stack1C] = Mon[Stack1[Stack1C - 1]];
		Stack1C++;
	}

/*	for (i=0;i<Stack1C;i++)
	{
		Stack2[Stack1C-1-i]=MoveId[Stack1[i]];
	}*/
	FillMemory(&Pnts[0], sizeof(Pnts), 0);
	FillMemory(&Roads[0], sizeof(Roads), 0);
	if (Stack1C != MaxPoints)
	{

		for (i = 0; i < Stack1C; i++)
		{
			Stack2[Stack1C-1-i] = MoveId[Stack1[i]];
			Pnts[Stack1[i] - 1] = True;
		};

		for (i = 0; i < Stack1C - 1; i++)
		{
			Roads[MoveId[Stack1[i]]] = True;
		};
	}
	return(Stack1C);
}


//---------------------------------------------------------------------------
__fastcall TfMain::TfMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfMain::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TfMain::Points1Click(TObject *Sender)
{
	Points1->Checked = !Points1->Checked;
	FillImageM();
}
//---------------------------------------------------------------------------
void __fastcall TfMain::Lines1Click(TObject *Sender)
{
	Lines1->Checked = !Lines1->Checked;
	FillImageM();
}
//---------------------------------------------------------------------------
void TfMain::FillImageM()
{
	int i, j;
	int X1, Y1, X2, Y2, X, Y;
	TColor C;
	TRect R;
	ImageM->Picture->Bitmap->Width = ImageM->Width;
	ImageM->Picture->Bitmap->Height = ImageM->Height;
	R.Left = 0;
	R.Bottom = 0;
	R.Right = ImageM->Width;
	R.Top = ImageM->Height;

	int MW = ImageM->Width;
	int MH = ImageM->Height;

	if ((MinX == MaxX) || (MinY == MaxY)) return;

	ZoomX = ImageM->Width / (MaxX - MinX);
	ZoomY = ImageM->Height / (MaxY - MinY);

	TCanvas *Canvas = ImageM->Picture->Bitmap->Canvas;

	ImageM->Picture->Bitmap->Canvas->Brush->Color = clWindow;
	ImageM->Picture->Bitmap->Canvas->FillRect(R);

	int OX = 0;
	int OY = 0;

	if (Lines1->Checked)
	for (i = 0; i < FieldsSCount; i++)
	{
		if (Roads[i])
			C = clRed;
		else
			C = clBlack;

		for (j = 1; j < FieldsS[i].PolyLine.Length; j++)
		{
			X1 = floor(ZoomX * (FieldsS[i].PolyLine[j - 1].x - MinX)) - OX;
			if ((X1 < 0) || (X1 >= MW)) continue;
			Y1 = floor(ZoomY * (-FieldsS[i].PolyLine[j - 1].y - MinY)) - OY;
			if ((Y1 < 0) || (Y1 >= MH)) continue;
			X2 = floor(ZoomX * (FieldsS[i].PolyLine[j - 0].x - MinX)) - OX;
			if ((X2 < 0) || (X2 >= MW)) continue;
			Y2 = floor(ZoomY * (-FieldsS[i].PolyLine[j - 0].y - MinY)) - OY;
			if ((Y2 < 0) || (Y2 >= MH)) continue;

			ImageM->Picture->Bitmap->Canvas->Pen->Color = C;
			ImageM->Picture->Bitmap->Canvas->MoveTo(X1, Y1);
			ImageM->Picture->Bitmap->Canvas->LineTo(X2, Y2);
		};
	};

	if (Points1->Checked)
	for (i = 0; i < FieldsMCount; i++)
	{
		X = floor(ZoomX * (FieldsM[i].X - MinX)) - OX;
		if ((X < 0) || (X >= MW)) continue;
		Y = floor(ZoomY * (-FieldsM[i].Y - MinY)) - OY;
		if ((Y < 0) || (Y >= MH)) continue;

		C = clBlack;
		if (Pnts[i])
		{
			C = clRed;
		};
		if (i == StartPoint)
		{
			C = clBlue;
			Canvas->Brush->Style = bsSolid;
			Canvas->Brush->Color = C;
			Canvas->Ellipse(X - 2, Y - 2, X + 3, Y + 3);
		};
		if (i == NearPoint)
		{
			C = clBlue;
			Canvas->Brush->Style = bsSolid;
			Canvas->Brush->Color = C;
			Canvas->Ellipse(X - 2, Y - 2, X + 3, Y + 3);
		};

		Canvas->Pixels[X][Y] = C;
		Canvas->Pen->Color = C;
		Canvas->Brush->Style = bsSolid;
		Canvas->Brush->Color = C;
		Canvas->Ellipse(X - 1, Y - 1, X + 2, Y + 2);
		LNext:
	};
	X1 = MapCX - OX;
	Y1 = MapCY - OY;
	if ((X1 > 0) && (X1 < MW - 1) && (Y1 > 0) && (Y1 < MH - 1))
	{
		Canvas->Pixels[X1 - 1][Y1 - 1] = clGray;
		Canvas->Pixels[X1 - 1][Y1 + 1] = clGray;
		Canvas->Pixels[X1 + 1][Y1 - 1] = clGray;
		Canvas->Pixels[X1 + 1][Y1 + 1] = clGray;
	};

}
//---------------------------------------------------------------------------
void __fastcall TfMain::FormCreate(TObject *Sender)
{
	WorkDir = GetCommandLine();
	int i;
	if (WorkDir[1] == '"')
	{
		WorkDir.Delete(1, 1);
		i = WorkDir.Pos('"');
		if (i > 0) WorkDir.Delete(i, WorkDir.Length() - i + 1);
	}
	else
	{
		i = WorkDir.Pos(' ');
		WorkDir.Delete(i, WorkDir.Length() - i + 1);
	};

	ExeFileName = WorkDir;

	for (i = WorkDir.Length(); i--; i > 0)
	{
		if (i == 0)
		{
			WorkDir = "";
			break;
		};
		if (WorkDir[i] == '\\')
		{
			WorkDir.SetLength(i);
			break;
		};
	};

	OpenDialog1->FileName = WorkDir + "Maps\\M*.mif";

	FillImageM();
}
//---------------------------------------------------------------------------
void __fastcall TfMain::Open1Click(TObject *Sender)
{
	if (OpenDialog1->Execute())
	{
		if (ExtractFileName(OpenDialog1->FileName)[1] != 'M') return;
		FreeMaps();
		Close1->Enabled = true;
		ReadFromFile(OpenDialog1->FileName);
		FillImageM();
		ImageM->Visible = true;
		PanelM->Visible = true;
	}
}
//---------------------------------------------------------------------------
TFlo GetLen(TFlo fi0, TFlo lam0, TFlo fi, TFlo lam)
{
	return sqrt((fi0 - fi) * (fi0 - fi) + (lam0 - lam) * (lam0 - lam));
};

//---------------------------------------------------------------------------
void __fastcall TfMain::ImageMMouseMove(TObject *Sender, TShiftState Shift,
			int X, int Y)
{
	TFlo Len, BestLen;
	int i, j;
	int NewNearPoint;

	BestLen = MaxInt;
	NewNearPoint = 0;
	MapCX = X + OX;
	MapCY = Y + OY;
	TFlo MapX, MapY;
	MapX = MinX + (X + OX) / ZoomX;
	MapY = -MinY - (Y + OY) / ZoomY;
	EditX->Text = FloatToStrF(MapX, ffFixed, 8, 6);
	EditX->Repaint();
	EditY->Text = FloatToStrF(MapY, ffFixed, 8, 6);
	EditY->Repaint();
	for (i = 0; i < FieldsMCount; i++)
	{
		Len = GetLen(FieldsM[i].X, FieldsM[i].Y, MapX, MapY);
		if (Len < BestLen)
		{
			BestLen = Len;
			NewNearPoint = i;
		};
	};
	if (NewNearPoint != NearPoint)
	{
		NearPoint = NewNearPoint;
		if (FieldsMCount > 0)
		{
			EditCode->Text = IntToStr(FieldsM[NearPoint].Code);
//			EditCode->Text = FieldsM[NearPoint].X;
			EditIndex->Text = IntToStr(NearPoint);
		}
		else
		{
			EditCode->Text = "";
			EditIndex->Text = "";
		};
		EditCode->Repaint();
		EditIndex->Repaint();

		if ((StartPoint >= 0) && (NearPoint >= 0))
			i = WayCalc(FieldsM[StartPoint].Code, FieldsM[NearPoint].Code);
		else
			i = -1;
		EditL->Text = IntToStr(i);
		EditL->Repaint();
	};
	FillImageM();
}
//---------------------------------------------------------------------------
void __fastcall TfMain::Close1Click(TObject *Sender)
{
	FreeMaps();
	ImageM->Visible = false;
	PanelM->Visible = false;
	Close1->Enabled = false;
	FillImageM();
}
//---------------------------------------------------------------------------

void __fastcall TfMain::ImageMMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	StartPoint = NearPoint;
	ImageMMouseMove(Sender, Shift, X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TfMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	Close1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfMain::FormResize(TObject *Sender)
{
	FillImageM();
}
//---------------------------------------------------------------------------

